=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2007-05-21 07:37:15 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-06-19 13:49:09 +0000
@@ -56,7 +56,8 @@
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
-            revid = None
+            revid = h.last_revid
+
         path = None
         if len(args) > 1:
             path = '/'.join(args[1:])
@@ -69,12 +70,6 @@
 
         if file_id is None:
             file_id = h.get_file_id(revid, path)
-
-        try:
-            revid_list, revid = h.get_file_view(revid, file_id)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
             
         # no navbar for revisions
         navigation = util.Container()

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-05-30 08:57:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-06-18 19:26:32 +0000
@@ -63,7 +63,11 @@
             if len(revid_list) == 0:
                 scan_list = revid_list
             else:
-                scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
+                if revid in revid_list: # XXX is this always true?
+                    i = revid_list.index(revid)
+                else:
+                    i = None
+                scan_list = revid_list[i:]
             entry_list = scan_list[:pagesize]
             entries = h.get_changes(entry_list)
         except:
@@ -77,7 +81,7 @@
                                     file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(h, navigation)
+        util.fill_in_navigation(navigation)
         
         entries = list(entries)
         # add parent & merge-point branch-nick info, in case it's useful

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2007-03-26 06:32:39 +0000
+++ loggerhead/controllers/revision_ui.py	2007-06-12 15:57:50 +0000
@@ -65,7 +65,7 @@
                                     pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(h, navigation)
+        util.fill_in_navigation(navigation)
 
         if compare_revid is not None:
             change = h.get_diff(compare_revid, revid)

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-05-30 08:57:43 +0000
+++ loggerhead/history.py	2007-06-19 13:52:22 +0000
@@ -189,9 +189,11 @@
         z = time.time()
         self = cls()
         self._branch = branch
-        self._history = branch.revision_history()
-        self._last_revid = self._history[-1]
-        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        self._last_revid = self._branch.last_revision()
+        if self._last_revid is not None:
+            self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        else:
+            self._revision_graph = {}
         
         if name is None:
             name = self._branch.nick
@@ -202,14 +204,11 @@
         self._revision_info = {}
         self._revno_revid = {}
         self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
-        count = 0
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
             self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
-            count += 1
-        self._count = count
 
         # cache merge info
         self._where_merged = {}
@@ -229,9 +228,10 @@
 
     @with_branch_lock
     def out_of_date(self):
-        if self._branch.revision_history()[-1] != self._last_revid:
-            return True
-        return False
+        if self._branch.__class__ is not \
+               bzrlib.branch.Branch.open(self._branch.base).__class__:
+            return False
+        return self._branch.last_revision() != self._last_revid
 
     def use_cache(self, cache):
         self._change_cache = cache
@@ -266,8 +266,6 @@
     
     last_revid = property(lambda self: self._last_revid, None, None)
     
-    count = property(lambda self: self._count, None, None)
-
     @with_branch_lock
     def get_config(self):
         return self._branch.get_config()
@@ -283,24 +281,9 @@
         seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
         return revno_str
 
-    def get_sequence(self, revid):
-        seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
-        return seq
-    
     def get_revision_history(self):
         return self._full_history
     
-    def get_revid_sequence(self, revid_list, revid):
-        """
-        given a list of revision ids, return the sequence # of this revid in
-        the list.
-        """
-        seq = 0
-        for r in revid_list:
-            if revid == r:
-                return seq
-            seq += 1
-    
     def get_revids_from(self, revid_list, revid):
         """
         given a list of revision ids, yield revisions in graph order,
@@ -444,7 +427,6 @@
             revid = self._last_revid
         if file_id is not None:
             # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
-            inv = self._branch.repository.get_revision_inventory(revid)
             revlist = list(self.get_short_revision_history_by_fileid(file_id))
             revlist = list(self.get_revids_from(revlist, revid))
         else:
@@ -520,22 +502,17 @@
             path = '/' + path
         return self._branch.repository.get_revision_inventory(revid).path2id(path)
     
-    def get_where_merged(self, revid):
-        try:
-            return self._where_merged[revid]
-        except:
-            return []
-    
+
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
         """
-        if revid in self._history:
+        if '.' not in self.get_revno(revid):
             return []
         
         merge_point = []
         while True:
-            children = self.get_where_merged(revid)
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
                 child_parents = self._revision_graph[child]
@@ -861,7 +838,6 @@
             if posixpath.dirname(filepath) != path:
                 continue
             filename = posixpath.basename(filepath)
-            rich_filename = filename
             pathname = filename
             if entry.kind == 'directory':
                 pathname += '/'
@@ -872,7 +848,7 @@
             change = util.Container(date=datetime.datetime.fromtimestamp(revision.timestamp),
                                     revno=self.get_revno(revid))
             
-            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
+            file = util.Container(filename=filename, executable=entry.executable, kind=entry.kind,
                                   pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
             file_list.append(file)
         

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2007-01-21 00:05:52 +0000
+++ loggerhead/templates/browse.kid	2007-06-08 11:52:33 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${util.ago(view.last_updated())} </td>
+            <td class="last-update"> ${view.get_history().last_revid and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2007-01-21 00:05:52 +0000
+++ loggerhead/templates/changelog.kid	2007-06-08 11:52:33 +0000
@@ -31,6 +31,10 @@
     Sorry, no results found for your search.
 </span>
 
+<span py:if="not changes">
+    No revisions!
+</span>
+
 <span py:if="not search_failed" class="changelog"> ${collapse_all_button('cl')} </span>
 
 <div class="log-entries">

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2007-05-30 08:49:57 +0000
+++ loggerhead/tests/test_simple.py	2007-06-08 12:05:55 +0000
@@ -20,49 +20,65 @@
     assert 'loggerhead branches' in cherrypy.response.body[0]
 
 
-class TestWithSimpleTree(object):
-    config_template = """
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-    """
+class BasicTests(object):
+
+
+    # there are so i can run it with py.test and take advantage of the
+    # error reporting...
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
     def setUp(self):
-
-        logging.basicConfig(level=logging.DEBUG)
-
+        #logging.basicConfig(level=logging.DEBUG)
+        self.bzrbranch = None
+        self.old_bzrhome = None
+
+    def createBranch(self):
         self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
         self.bzrbranch = tempfile.mkdtemp()
-        branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
+        self.branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
             self.bzrbranch, force_new_tree=True)
-        tree = branch.bzrdir.open_workingtree()
+        self.tree = self.branch.bzrdir.open_workingtree()
+
+    config_template = """
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+    """
+
+    def setUpLoggerhead(self):
+        ini = self.config_template%dict(branch=self.bzrbranch)
+
+        config = ConfigObj(ini.splitlines())
+        cherrypy.root = Root(config)
+
+    def tearDown(self):
+        if self.bzrbranch is not None:
+            shutil.rmtree(self.bzrbranch)
+        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
+
+class TestWithSimpleTree(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+
         f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
         self.filecontents = 'some\nmultiline\ndata'
         try:
             f.write(self.filecontents)
         finally:
             f.close()
-        tree.add('myfilename')
-        self.fileid = tree.path2id('myfilename')
+        self.tree.add('myfilename')
+        self.fileid = self.tree.path2id('myfilename')
         self.msg = 'a very exciting commit message'
-        self.revid = tree.commit(message=self.msg)
-
-        ini = self.config_template%dict(branch=self.bzrbranch)
-
-        config = ConfigObj(ini.splitlines())
-        cherrypy.root = Root(config)
-
-    def tearDown(self):
-        shutil.rmtree(self.bzrbranch)
-        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
-
-    # there are so i can run it with py.test and take advantage of the
-    # error reporting...
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
+        self.revid = self.tree.commit(message=self.msg)
+
+        self.setUpLoggerhead()
 
     def test_index(self):
         testutil.create_request('/')
@@ -96,3 +112,30 @@
             folder = '%(branch)s'
             cachepath = '%(branch)s/cache'
     """
+
+class TestEmptyBranch(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+        self.setUpLoggerhead()
+
+    def test_index(self):
+        testutil.create_request('/')
+        link = '<a href="/project/branch">branch</a>'
+        assert link in cherrypy.response.body[0]
+
+    def test_changes(self):
+        testutil.create_request('/project/branch/changes')
+        assert 'No revisions!' in cherrypy.response.body[0]
+
+class TestEmptyBranchWithCache(TestEmptyBranch):
+    config_template = """
+    testing = True
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+            cachepath = '%(branch)s/cache'
+    """
+

=== added file 'loggerhead/tests/test_upgrade.py'
--- loggerhead/tests/test_upgrade.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_upgrade.py	2007-06-19 13:52:22 +0000
@@ -0,0 +1,31 @@
+from loggerhead.tests.test_simple import BasicTests
+
+import os
+from turbogears import testutil
+import cherrypy
+
+class TestSurviveOverUpgrade(BasicTests):
+
+    def test_upgrade(self):
+        self.createBranch()
+
+        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
+        try:
+            f.write("foo")
+        finally:
+            f.close()
+        self.tree.add('myfilename')
+        msg = 'a very exciting commit message'
+        self.tree.commit(message=msg)
+
+        self.setUpLoggerhead()
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]
+
+        from bzrlib.upgrade import upgrade
+        from bzrlib.bzrdir import format_registry
+        upgrade(self.bzrbranch, format_registry.make_bzrdir('dirstate-tags'))
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-03-12 17:51:19 +0000
+++ loggerhead/util.py	2007-06-12 15:57:50 +0000
@@ -272,13 +272,14 @@
     return out
     
 
-def fill_in_navigation(history, navigation):
+def fill_in_navigation(navigation):
     """
     given a navigation block (used by the template for the page header), fill
     in useful calculated values.
     """
-    navigation.position = history.get_revid_sequence(navigation.revid_list, navigation.revid)
-    if navigation.position is None:
+    if navigation.revid in navigation.revid_list: # XXX is this always true?
+        navigation.position = navigation.revid_list.index(navigation.revid)
+    else:
         navigation.position = 0
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1

